var Umeditor = {};
var ue = {};
var timeOutEvent = 0;
// 记录长按的图片节点，用于删除
var lastLongPressImgNote = {};
// 记录长按的语音节点，用于删除
var lastLongPressAudioNote = {};
var initEditorHeight = 0;
Umeditor.init = function () {
    var config = {
        autoFloatEnabled: false,
        wordCount: false,
        elementPathEnabled: false,
        allowDivTransToP: false,
        enableContextMenu: false,
        removeFormatAttributes: ['lang,width,height,align,hspace,valign'],
        minFrameHeight: initEditorHeight,
        initialFrameHeight: initEditorHeight,
        focus: true,
        insertunorderedlist: {
            // 自定的样式
            'checkbox': 'checkbox'
        }
    };
    ue = UE.getEditor('editor', config);
    registerTodoList(ue);
    ue.addListener('ready', function (editor) {
        Umeditor.doHtmlReady();
    });

    ue.addListener('focus', function (editor) {
        Umeditor.editorFocusChange(true);
    });
    ue.addListener('blur', function (editor) {
        Umeditor.editorFocusChange(false);
    });

    ue.addListener('click', function (type, e) {
        if (e.target.tagName.toLowerCase() == 'img' && ue.body.contentEditable != 'false') {
            var src = $(e.target).attr('src');
            var index;
            var content = '';
            $(ue.body).find('img').each(function (index, img) {
                var imgSrc = $(img).attr('src');
                content += imgSrc;
                content += ';';
            });
            Umeditor.imgClick(src, content);
            // 移除光标
            ue.blur();
        } else if (e.target.tagName.toLowerCase() == 'a' && ue.body.contentEditable != 'false') {
            var href = e.target.href;
            Umeditor.aClick(href);
        }
    });

    ue.addListener('touchstart', function (type, e) {
        if (e.target.tagName.toLowerCase() == 'img' && ue.body.contentEditable != 'false') {
            timeOutEvent = setTimeout(function () {
                timeOutEvent = 0;
                lastLongPressImgNote = e.target;
                Umeditor.imgLongPress('');
            }, 500);

        } else if (e.target.tagName.toLowerCase() == 'div' && $(e.target).hasClass('audio-container') && ue.body.contentEditable != 'false') {
            timeOutEvent = setTimeout(function () {
                timeOutEvent = 0;
                lastLongPressAudioNote = $(e.target).find('audio');
                Umeditor.audioLongPress('');
            }, 500);
        }
    });

    ue.addListener('touchmove', function (type, e) {
        if (e.target.tagName.toLowerCase() == 'img' && ue.body.contentEditable != 'false') {
            clearTimeout(timeOutEvent);
            timeOutEvent = 0;
        } else if (e.target.tagName.toLowerCase() == 'div' && $(e.target).hasClass('audio-container') && ue.body.contentEditable != 'false') {
            clearTimeout(timeOutEvent);
            timeOutEvent = 0;
        }
    });

    ue.addListener('touchend', function (type, e) {
        if (e.target.tagName.toLowerCase() == 'img' && ue.body.contentEditable != 'false') {
            clearTimeout(timeOutEvent);
        } else if (e.target.tagName.toLowerCase() == 'div' && $(e.target).hasClass('audio-container') && ue.body.contentEditable != 'false') {
            clearTimeout(timeOutEvent);
        }
    });

// 监听粘贴语音时设置回contentEditable属性属性丢失，设置回contentEditable属性
    ue.addListener('beforepaste', function (type, html) {
        var root = UE.htmlparser(html.html, true);
        root.traversal(function (node) {
            var className = node.getAttr('class');
            if ('audio-container clearfix' === className) {
                node.setAttr('contentEditable', 'false');
            }
            if (node.tagName == "audio" && node.getAttr('class').indexOf('loaded') != -1) {
                 node.setAttr('class', '');
            }
        });
        html.html = root.toHtml();
    });

    ue.addListener('afterpaste', function () {
        // 黏贴后加语音监听
        Umeditor.updateAudioStyle();
    });
};

Umeditor.replaceImgSrc = function (src) {
    $(ue.body).find('img').each(function (i, image) {
        if ($(image).attr('data-url') == src){
            var img = new Image();
            img.src = src;
            // 判断图片是否在缓存中
            if (img.complete) {
                if(typeof($(image).attr('data-imgwidth')) == 'undefined'){
                    $(image).attr('data-imgwidth',img.width);
                }
                if(typeof($(image).attr('data-imgheight')) == 'undefined'){
                    $(image).attr('data-imgheight',img.height);
                }
                $(image).attr('src', src);
                $(image).removeAttr('width');
                $(image).removeAttr('height');
                ue.fireEvent('contentchange');
            } else {
                img.onload = function () {
                    $(image).removeAttr('width');
                    $(image).removeAttr('height');
                    if(typeof($(image).attr('data-imgwidth')) == 'undefined'){
                        $(image).attr('data-imgwidth',img.width);
                    }
                    if(typeof($(image).attr('data-imgheight')) == 'undefined'){
                        $(image).attr('data-imgheight',img.height);
                    }
                    $(image).attr('src', src);
                    ue.fireEvent('contentchange');
                };
                img.onerror = function () {
                    $(image).removeAttr('style');
                    $(image).attr('style', 'background:#e9e9e9 url(\"file:///android_asset/themes/image_fail.png\") no-repeat center center;');
                    ue.fireEvent('contentchange');
                };
            }
        }
    });
};

Umeditor.aClick = function (href) {
    Umeditor.callback("callback-editor-a-click", href);
};

/**
 * 暂停音频播放
 * @param path
 */
Umeditor.pauseAudio = function () {
    stopAllAudio();

};

/**
 * 插入音频
 * @param path
 */
Umeditor.insertAudio = function (url) {
    var html = '<div class="audio-container clearfix" contenteditable="false"><audio src="' + url + '" preload="auto" controls="controls"></audio><button class="play-state pause"></button><input type="range" min="0" max="100" class="range" value="0" step="any"/><p class="duration"><span class="current">00:00</span><span class="time_split"> / </span><span class="total">--:--</span></p><button contenteditable="false" class="remove-audio"/></div>';
    Umeditor.setHtml(html);
    Umeditor.updateAudioStyle();

};

/**
 * 更新音频地址
 * @param path
 */
Umeditor.updateAudioPath = function (url) {
    var tempValue = url.split('/');
    var fileName = '';
    if (tempValue != null && tempValue.length > 0) {
        fileName = tempValue[tempValue.length - 1];
    }
    $(ue.body).find('audio').each(function (index, audio) {
        var oldPath = $(audio).attr('src');
        if (oldPath == fileName) {
            $(audio).attr('src', url);
            $(audio).siblings('.play-state').removeAttr('disabled');

        }
    });

};

/**
 * 插入文本
 * @param text
 */
Umeditor.insertText = function (text) {
    Umeditor.setHtml(text);
};

/**
 * 插入todolist
 */
Umeditor.insertChecklist = function () {
    // 插入todolist时，如果光标在音频div内，则往内容的最后插入
    var rng = ue.selection.getRange();
    var div = UE.dom.domUtils.findParentByTagName(rng.startContainer, 'div', true);
    if (div && $(div).hasClass('play-state')) {
        ue.focus(true);
    }
    ue.execCommand('insertunorderedlist', 'checkbox');
    // 移动到光标位置
    Umeditor.scrollToSection();
};

/**
 * 更新临时识别结果
 *
 * @param text
 */
Umeditor.updateTempContentValue = function (text) {
    if ($(ue.body).find('.temp_content').size() === 0) {
        Umeditor.setHtml('<p contenteditable=\'false\' class=\'temp_content\'>' + text + '</p>');
    } else {
        $(ue.body).find('.temp_content').html(text);
    }
};

/**
 * 清除临时识别结果样式
 */
Umeditor.clearTempContentStyle = function () {
    $(ue.body).find('.temp_content').removeAttr('contenteditable').removeClass('temp_content').addClass('audio_text');
};

/**
 *  设置最终识别结果
 *
 * @param text
 */
Umeditor.setResultContentValue = function (text) {
    $(ue.body).find('.temp_content').remove();
    Umeditor.setHtml('<p class=\'audio_text\'>' + text + '</p>');
};

Umeditor.setTimePlaceholder = function (text) {
    $('#zss_field_time').text(text);
};

Umeditor.setContent = function (content, isAppendTo) {
    ue.setContent(content, isAppendTo);
    Umeditor.updateAudioStyle();
};

/**
 *  请求更新笔记内容
 *
 */
Umeditor.requestUpdateNote = function () {
    Umeditor.callback('callback-response-update-note', ue.getContent());
};

/**
 *  插入html代码
 *
 * @param text
 */
Umeditor.setHtml = function (html) {
    var rng = ue.selection.getRange();
    var div = UE.dom.domUtils.findParentByTagName(rng.startContainer, 'div', true);
    if (div && $(div).hasClass('play-state')) {
        ue.focus(true);
    }
    ue.execCommand('inserthtml', html);
};

/**
 *  删除长按的img节点
*/
Umeditor.delLongPressImgNote = function () {
    if (lastLongPressImgNote) {
        var parent = $(lastLongPressImgNote).parent();
        if($(parent).is('div')){
            parent.remove();
            ue.fireEvent('contentchange');
        }
    }
};

/**
 *   根据inde旋转img节点
*/
Umeditor.rotateImgNoteByIndex = function (index, rotate) {
    $(ue.body).find('img').each(function (i, img) {
        if (i == index) {
            $(img).css('transform', 'rotate(' + rotate + 'deg)');
            ue.fireEvent('contentchange');
            return false;
        }
    });
};

/**
 *   根据index删除img节点
*/
Umeditor.delImgNoteByIndex = function (index) {
    $(ue.body).find('img').each(function (i, img) {
        if (i == index) {
            var parent = $(img).parent()
            if($(parent).is('div')){
                parent.remove();
                ue.fireEvent('contentchange');
                return false;
            }
        }
    });
};

/**
 *   根据src删除audio标签
*/
Umeditor.delAudioBySrc = function (src) {
    if (lastLongPressAudioNote) {
        var parent = $(lastLongPressAudioNote).parent();
        if($(parent).is('div')){
            parent.remove();
            ue.fireEvent('contentchange');
        }
    }
};

/**
 *   滚动编辑器到光标所在位置
*/
Umeditor.scrollToSection = function () {
    setTimeout(function () {
        var range = ue.selection.getRange();
        range.scrollToView(ue.autoHeightEnabled, ue.autoHeightEnabled ? UE.dom.domUtils.getXY(ue.iframe).y : 0);
    }, 100);
};


/**
 *   根据延迟时间，取消焦点
*/
Umeditor.blurDelay = function (time) {
    setTimeout(function () {
        ue.blur();
    }, time);
};

/**
 *  取消焦点
*/
Umeditor.blur = function () {
    ue.blur();
};

/**
 *   获取焦点
*/
Umeditor.focus = function (toEnd) {
    ue.focus(toEnd);
};

Umeditor.setDisable = function () {
    $('#zss_field_title').attr('contenteditable', false);
    ue.setDisabled();
};

Umeditor.onListening = function () {
    ue.focus(true);
    stopAllAudio();
}

Umeditor.setInitialFrameHeight = function (height) {
    ue.options.initialFrameHeight = height;
    ue.options.minFrameHeight = height;
    ue.fireEvent('contentchange');
};

// ---------------------------------------- 语音样式 -------------------------------------------------
Umeditor.updateAudioStyle = function () {
    $(ue.body).find('audio').each(function (index, audioItem) {
        if (!$(audioItem).hasClass('loaded')) {
            $(audioItem).addClass('loaded');
            $(audioItem).siblings('.play-state').removeClass('play').removeClass('pause').addClass('pause');
            $(audioItem).siblings('input').removeClass('play').removeClass('pause').addClass('pause');
            audioItem.addEventListener('loadedmetadata',
            function () {
                var playTime = $(this).siblings('input').val();
                this.setAttribute('audioInterval', null);
                this.currentTime = playTime * audioItem.duration / 100.0;
                var durationEl = $(audioItem).siblings('.duration');
                durationEl.find('.total').html(timeToStr(this.duration));
                durationEl.find('.current').html(timeToStr(this.currentTime));
            });

            audioItem.onended = function () {
                stopAudio(audioItem);
                var $playstate = $(this).siblings('.play-state');
                $playstate.removeClass('play').removeClass('pause').addClass('pause');
                var $input = $(this).siblings('input');
                $input.attr('value', 100);
                $input.val(100);
                $input.css('background', '#4a4a4a');
                $input.removeClass('play').removeClass('pause').addClass('pause');
            }
            $(audioItem).siblings('input').bind('input',
            function (e) {
                var $input = $(this);
                var thisAudio = $(this).siblings('audio')[0];
                $input.attr('value', this.value);
                $input.css('background', 'linear-gradient(to right, #4a4a4a 0%, #4a4a4a '
                    + this.value + '%,#e9e9e9 ' + this.value + '%, #e9e9e9)');

                thisAudio.currentTime = this.value * thisAudio.duration / 100;
                $input.siblings('.duration').find('.current').html(timeToStr(thisAudio.currentTime));

                if (thisAudio.ended || thisAudio.paused) {
                    playAudio(thisAudio);
                    var $playstate = $(thisAudio).siblings('.play-state');
                    $playstate.removeClass('pause').addClass('play');
                    $(thisAudio).siblings('input').removeClass('pause').addClass('play');
                }
            });

            $(audioItem).siblings('.play-state').on('click',
            function (e) {
                if (e.target.className.indexOf('play-state') >= 0) {
                    var $this = $(e.target);
                    if ($this.hasClass('pause')) {
                        stopAllAudio();
                        $this.removeClass('pause').addClass('play');
                        $this.siblings('input').removeClass('pause').addClass('play');
                        var thisAudio = $this.siblings('audio')[0];
                        playAudio(thisAudio);
                        Umeditor.onAudioPlay();
                    } else {
                        var $this = $(e.target);
                        $this.removeClass('play').addClass('pause');
                        $this.siblings('input').removeClass('play').addClass('pause');
                        var thisAudio = $this.siblings('audio')[0];
                        stopAudio(thisAudio);
                        Umeditor.onAudioPause();
                    }
                }

            });

            $(audioItem).siblings(".remove-audio").click(function() {
                $(audioItem).parent().remove();
                Umeditor.onRemoveAudio();
                ue.fireEvent('contentchange');
            });

        }

    });
}

function timeToStr(time) {
    var m = 0,
    s = 0,
    mm = '00',
    ss = '00';
    time = Math.floor(time % 3600);
    m = Math.floor(time / 60);
    s = Math.floor(time % 60);
    ss = s < 10 ? '0' + s : s + '';
    mm = m < 10 ? '0' + m : m + '';
    return mm + ':' + ss;
}

function playAudio(thisAudio) {
    var me = this;
    thisAudio.play();

    var audioInterval = setInterval(function () {
        thisAudio.setAttribute('audioInterval', audioInterval);
        $(thisAudio).siblings('.duration').find('.current').html(me.timeToStr(thisAudio.currentTime));

        var durationEl = $(thisAudio).siblings('.duration');
        durationEl.find('.total').html(timeToStr(thisAudio.duration));
        var $input = $(thisAudio).siblings('input');
        var playTime = 100 * thisAudio.currentTime / thisAudio.duration;
        $input.css('background', 'linear-gradient(to right, #4a4a4a 0%, #4a4a4a '
            + playTime + '%,#e9e9e9 ' + playTime + '%, #e9e9e9)');
        $input.val(playTime);
        $input.attr('value', playTime);
    },
    60);
}

function stopAudio(thisAudio) {
    thisAudio.pause();
    var audioInterval = thisAudio.getAttribute('audioInterval');
    if (audioInterval) {
        clearInterval(audioInterval);
    }
    thisAudio.setAttribute('audioInterval', null);
}

function stopAllAudio() {
    var audios = ue.document.getElementsByTagName('audio');
    $(ue.body).find('audio').each(function (index, audioItem) {
        $(audioItem).siblings('.play-state').removeClass('play').removeClass('pause').addClass('pause');
        $(audioItem).siblings('input').removeClass('play').removeClass('pause').addClass('pause');
        stopAudio(audioItem);
    });
}

// ------------------------------------------------ 语音样式 ----------------------------------------------------------------
// ---------------------------callbacks----------------------------
// html加载完成
Umeditor.doHtmlReady = function () {
    Umeditor.callback('callback-html-loaded', '');
}

Umeditor.editorFocusChange = function (isFocus) {
    Umeditor.callback('callback-editor-focus-change', isFocus);
}

// 图片点击
Umeditor.imgClick = function (src, content) {
    var params = src + ',' + content;
    Umeditor.callback('callback-editor-img-click', params);
}

// 图片长按
Umeditor.imgLongPress = function (src) {
    Umeditor.callback('callback-editor-img-long-press', src);
}

// 音频长按
Umeditor.audioLongPress = function (src) {
    Umeditor.callback('callback-editor-audio-long-press', src);
}

// 音频长按
Umeditor.onAudioPlay = function (src) {
    Umeditor.callback('callback-editor-audio-play', src);
}

// 音频长按
Umeditor.onAudioPause = function (src) {
    Umeditor.callback('callback-editor-audio-pause', src);
}

// 音频快捷删除
Umeditor.onRemoveAudio = function () {
    Umeditor.callback('callback-editor-audio-fast-remove', '');
}

Umeditor.callback = function (callbackScheme, callbackPath) {
    var url = callbackScheme + ':';
    if (callbackPath) {
        url = url + callbackPath;
    }
    if (nativeState.androidApiLevel < 17) {
        Umeditor.callbackThroughIFrame(url);
    } else {
        nativeCallbackHandler.executeCallback(callbackScheme, callbackPath);
    }
};

/**
 *  @brief      Executes a callback by loading it into an IFrame.
 *  @details    The reason why we're using this instead of window.location is that window.location
 *              can sometimes fail silently when called multiple times in rapid succession.
 *              Found here:
 *              http://stackoverflow.com/questions/10010342/clicking-on-a-link-inside-a-webview-that-will-trigger-a-native-ios-screen-with/10080969#10080969
 *
 *  @param      url     The callback URL.
 */
Umeditor.callbackThroughIFrame = function (url) {
    var iframe = document.createElement('IFRAME');
    iframe.setAttribute('sandbox', '');
    iframe.setAttribute('src', url);

    // IMPORTANT: the IFrame was showing up as a black box below our text.  By setting its borders
    // to be 0px transparent we make sure it's not shown at all.
    //
    // REF BUG: https://github.com/wordpress-mobile/WordPress-iOS-Editor/issues/318
    //
    iframe.style.cssText = 'border: 0px transparent;';

    document.documentElement.appendChild(iframe);
    iframe.parentNode.removeChild(iframe);
    iframe = null;
};